<template>
  <section>
    <base-dialog
      :show="!!error"
      title="An error occurred!"
      @close="handleError"
    >
      <p>{{ error }}</p>
    </base-dialog>
    <base-card>
      <div>
        <span v-if="isVerified" class="verified">Verified</span>
      </div>
      <div class="center">
        <img
          :src="selectedProfile['picture']['large']"
          alt="User Picture"
          width="250"
          height="300"
        />
      </div>
      <div>
        <h3>
          {{ selectedProfile["firstName"] }} {{ selectedProfile["lastName"] }}
        </h3>
      </div>
      <div>
        <h4>{{ selectedProfile["email"] }}</h4>
      </div>
      <div>
        <h4>Address:</h4>
        {{ selectedProfile["address"] }}
      </div>
      <div>
        <h4>Birth Date:</h4>
        {{ selectedProfile["birthDate"] }}
      </div>
      <div>
        <h4>Register Date:</h4>
        {{ selectedProfile["registerDate"] }}
      </div>
      <div>
        <h4>Register Time:</h4>
        {{ selectedProfile["registerTime"] }}
      </div>
    </base-card>
  </section>
</template>

<script setup>
import { ref, defineProps, computed } from "vue";
import { useStore } from "vuex";
import BaseCard from "@/components/ui/BaseCard.vue";

const props = defineProps(["id"]);

const selectedProfile = ref(null);
const store = useStore();
const error = ref(null);

const isVerified = computed(function () {
  const users = store.getters.users;
  const selectedUser = users.find((user) => user.id === props.id);
  return selectedUser["isVerified"];
});

function handleError() {
  error.value = null;
}

try {
  selectedProfile.value = store.getters.users.find(
      (profile) => profile["id"] === props.id,
  );
} catch (error) {
  error.value = error.message || "Something went wrong";
}

if (selectedProfile.value === undefined) {
  error.value = "Something went wrong";

}
</script>

<style scoped>
h3 {
  font-size: 1.5rem;
}

h3,
h4 {
  margin: 0.5rem 0;
}

div {
  margin: 0.5rem 0;
}

.verified {
  background-color: #3d008d;
  color: white;
  border-radius: 30px;
  padding: 0.5rem 1.5rem;
  display: inline-block;
  margin-right: 0.5rem;
}
</style>
